//+------------------------------------------------------------------+
//|              EA_Crossing_Dynamic double zone WPR 2 dll_v1.00.mq4 |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""


#define  ORDERSELL  2
#define  ORDERBUY   1
#define  AUTHOR      "Grupo Renko"


extern string     ExpertName                    = "=== EA_Crossing_Dynamic double zone WPR 2 dll_v1.00 ===";

extern string     GeneralParameters             = "===== GENERAL PARAMETERS =====";
extern int        Magic                         = 456789;      // Manual magic number
extern bool       SpreadProtection              = true;        // Maximum spread protection
extern int        MaxSpreadPermitted            = 2;           // Value of maximum spread allowed
extern int        MaxSlippage                   = 2;           // Maximum slippage allowed
extern int        NumberOfTry                   = 3;           // Number of tries to modify the orders to the broker.
extern string     CustomComment                 = "Setting 1"; // Allow customize the comment of the EA


extern string     MoneyManagement               = "===== MONEY MANAGEMENT =====";
extern double     Lots                          = 0.01;        // Lot size

//When MM_Risk is disabled: use lot size. 
extern string     MM_Risk                       = "----- Risk Money Management -----";
extern bool       UseMoneyManagementRisk        = false;
extern double     RiskAB                        = 15;          // Risk is % of account balance to risk per sequence

//When MM_Martingale is active: value of initial lot.
extern string     MM_Martingale                 = "----- Martingale -----";
extern bool       UseMartingale_Loss            = false;
extern double     LotsMultiplier_Loss           = 2.0;          // Multiplication factor of lot per each lost operation.

// When Risk and MM_Martingale are both disabled: fixed lot size (Lots).
// If MM_Risk is active, never can be active MM_Martingale and viceversa (if MM_Martingale is active, never can be active MM_Risk).

extern string     OrderSettings                 = "===== ORDER SETTINGS =====";
// The orders are always a Market orders

extern int        MaxOrders                     = 1;     // Max Number of orders activas.                                           
                                                             
extern bool       OnlyBuyMode                   = true;  // Only Buy Mode switch
extern bool       OnlySellMode                  = true;  // Only Sell Mode switch



extern string     ExitSettingsActiveOrder       = "===== EXIT SETTINGS ACTIVE ORDER =====";
extern bool       CloseOnTrendChangeAO          = false; // Close the position when the trend has changed in WPR indicator,
                                                         // when there is an active order with TakeProfit and StopLoss.
                                                         // It means, it must be active UseControlBuy and UseControlSell.

// IF THERE IS AN OPEN ACTIVE ORDER AND WPR INDICATOR SHOW US ANOTHER SIGNAL TO ENTER INTO MARKET, IF THE UseControlBuy/UseControlSell IS ACTIVE, DO:
// SE PROCEDERA DEL SIGUIENTE MODO.

// When CloseOnTrendChange  = false
// 1- If exist an active order
// 2- And the signal don't touch Take Profit or Stop Loss (is still active)
// 3- Appear a new signal in WPR indicator: do nothing. Only wait until the price touch the Take Profit/Stop Loss
// 4- Once the order is closed, the EA will wait until the WPR indicator shows us a new signal.

// When CloseOnTrendChange  = true
// 1- If exist an active order
// 2- And the signal don't touch Take Profit or Stop Loss (is still active)
// 3- Appear a new signal in WPR indicator. Automatically, the EA must close the current order at the close bar price (the bar where the signal has appeared)
// 4- The EA enter into market at the same bar (when has been closed the last order).

extern string     ContinuousMode                  = "===== CONTINUOUS MODE =====";
extern bool       UseContinuousMode               = false; 

// When UseContinuousMode is active, the EA will work in continuous mode. It means that when a buy order has been closed, the EA open a sell order and 
// if the sell order has been closed, the EA open a new buy order. Never is out of the market. Always is trading.
// The WPR indicator is what decide to give us a sell signal or buy signal.
// This parameter can be active ONLY when ControlBuy and ControlSell are desactivated!
 
extern string     ControlBuy                    = "===== CONTROL BUY =====";
extern bool       UseControlBuy                 = true;

extern double     TakeProfitPipsBuy             = 200;
extern double     StopLossPipsBuy               = 200;
extern bool       HideBuyTP_SL                  = false;  // Hidden TakeProfit And StopLoss Mode
extern bool       UseBreakEvenBuy               = false;  // If BreakEven is active, TrailingStop can't be active
extern double     MoveToBreakEveAtPipsBuy       = 120;    // When the price moves to X benefit in pips move SL to BE
extern double     MoveToBreakEvenLockPipsBuy    = 50;     // When the price is BreakEven +/- x pips, move SL to BE
extern bool       UseTrailingStopBuy            = false;  // If the TrailingStop is active, Breakeven can't be active.
extern double     TrailingStopBuy               = 100;
extern double     TrailingStepBuy               = 50;
// If there is the BreakEven mode active, it can't be active TrailingStop mode.

extern string     ControlSell                   = "===== CONTROL SELL =====";
extern bool       UseControlSell                = true;

extern double     TakeProfitPipsSell            = 200;
extern double     StopLossPipsSell              = 200;
extern bool       HideSellTP_SL                 = false;  // Hidden TakeProfit And StopLoss Mode
extern bool       UseBreakEvenSell              = false;  // If BreakEven is active, TrailingStop can't be active
extern double     MoveToBreakEveAtPipsSell      = 120;    // When the price moves to X benefit in pips move SL to BE
extern double     MoveToBreakEvenLockPipsSell   = 50;     // When the price is BreakEven +/- x pips, move SL to BE
extern bool       UseTrailingStopSell           = false;  // If the TrailingStop is active, Breakeven can't be active.
extern double     TrailingStopSell              = 100;
extern double     TrailingStepSell              = 50;
// If there is the BreakEven mode active, it can't be active TrailingStop mode.


extern string     IndicatorsSettings            = "===== INDICATORS SETTINGS=====";
extern string     Note1__                           = "===== Double Dynamic Zone Williams Percent Range=====";
extern int        WprLength                     = 14;
extern int        WprSmooth                     =  3;
extern int        WprSmoothMode                 = MODE_SMA;
extern int        Average                       = 9;
extern int        AverageMode                   = MODE_SMA;
extern int        DzLookBackBars                = 70;
extern double     DzStartBuyProbability1        = 0.20;
extern double     DzStartSellProbability1       = 0.20;
extern double     DzStartBuyProbability2        = 0.06;
extern double     DzStartSellProbability2       = 0.06;
extern string     WprSmoothModes                = "";
extern string     __0                           = "SMA";
extern string     __1                           = "EMA";
extern string     __2                           = "Double smoothed EMA";
extern string     __3                           = "Double EMA (DEMA)";
extern string     __4                           = "Triple EMA (TEMA)";
extern string     __5                           = "Smoothed MA";
extern string     __6                           = "Linear weighted MA";
extern string     __7                           = "Parabolic weighted MA";
extern string     __8                           = "Alexander MA";
extern string     __9                           = "Volume weghted MA";
extern string     __10                          = "Hull MA";
extern string     __11                          = "Triangular MA";
extern string     __12                          = "Sine weighted MA";
extern string     __13                          = "Linear regression";
extern string     __14                          = "IE/2";
extern string     __15                          = "NonLag MA";
extern string     __16                          = "Zero lag EMA";
extern string     __17                          = "Leader EMA";
extern string     __18                          = "Super smoother";
extern string     __19                          = "Smoother";


extern string     Alerts                        = "===== ALERTS =====";
extern bool       ShowMessages                  = true;
extern bool       ShowAlerts                    = true;

bool dummyResult;

//Message:(It shows a message on the template that disappears at the moment of fix the error)

//"Parameters Error MM" = When there is activated both of MONEY MANAGEMENT (MM_Risk and MM_Martingale). These are incompatibles! They can't be activated at the same time

//"Error Parametros ExitSettingsActiveOrder" = Cuando no esten activos UseControlBuy y UseControlSell, tienen que estar los
// dos activos, solo uno activo nos daria tambien el mensaje.

// "Parameters Error ContinuousMode" = when UseContinuousMode is activated and UseControlBuy or UseControlSell too. It can be activated at the same time.
// Also can't be activated UseControlBuy=True and UseControlSell=False at the same time.

//"Parameter Errors ControlBuy" = It will be active when we will have UseBreakEvenBuy and UseTrailingStopBuy activated at the same time. It can't be posible. Only one of them or neither.

//"Parameter Error ControlSell" = It shows an error when UseBreakEvenSell and UseTrailingStopSell are activated at the same time. It can't be posible. Only one of them or neither. 

//"Breakeven And TrailingStop Errors" = When there is some error moving the StopLoss (trailing stop or breakeven)

//**********************************************************************************************************************************************************
//**********************************************************************************************************************************************************

datetime glTimeSignal;
double glPriceSignal;
double glTrailing[10][10];
int init()
{
   glTimeSignal=TimeCurrent();
   glPriceSignal=Bid;
   return(0);
}
int deinit()
{
   GrupoRenko();
   return(0);
}

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+

bool glErrorBool[10];

int start()
{
   GrupoRenko();
   int TradeTrend;
   bool TradeAllow;
   int TK;
   double Slipage=0;
   double lcLots;
   int Ticket;
   
   if((UseMoneyManagementRisk==true)&&(UseMartingale_Loss==true)) glErrorBool[1]=true;
   if((UseContinuousMode==true)&&((UseControlBuy==true)||(UseControlSell==true))) glErrorBool[3]=true;
   if((UseBreakEvenBuy==true)&&(UseTrailingStopBuy==true)) glErrorBool[4]=true;
   if((UseBreakEvenSell==true)&&(UseTrailingStopSell==true)) glErrorBool[5]=true;
   if(((UseControlBuy==true)&&(UseControlSell==false))||((UseControlBuy==false)&&(UseControlSell==true))) glErrorBool[7]=true;
   sAlert(glErrorBool);

   if(UseMoneyManagementRisk==true) sMoneyManager(lcLots,RiskAB);
   if(UseMoneyManagementRisk==false)
   {
      if(UseMartingale_Loss ==true)
      {
         Ticket=sOrderLast();
         if(Ticket!=0)
         {
            dummyResult = OrderSelect(Ticket,SELECT_BY_TICKET);
            if(OrderProfit()<0) lcLots=LotsMultiplier_Loss*OrderLots();
         }
      }
   }
   if(lcLots<=0) lcLots=Lots;
   lcLots=NormalizeDouble(lcLots,2);
   
   TradeTrend=sWPRSignal(Period(),glTimeSignal,glPriceSignal);
   sLimitOrder(TradeAllow,Period(),glTimeSignal,MaxOrders);
   if((SpreadProtection==true)&&(1.0*(Ask-Bid)/sPoint()>MaxSpreadPermitted)) TradeAllow=false;
   
   if(sOrderSum(Magic)>0)
   {
      if(UseContinuousMode==true)
      {
         if((UseControlBuy==true)&&(UseControlSell==true)) sCloseTrendChange(TradeTrend,Magic);
      }
      if(UseContinuousMode==false)
      {
         if(CloseOnTrendChangeAO==true) sCloseTrendChange(TradeTrend,Magic);
         if(CloseOnTrendChangeAO==false)
         {
            TradeAllow=false;
         }
      }
   }
   if(TradeAllow==true)
   {
      switch(TradeTrend)
      {
      case ORDERBUY:
         if(OnlySellMode!=true)
         {
            for(int i=0;i<NumberOfTry;i++)
            {
               TK=OrderSend(Symbol(),OP_BUY,lcLots,Ask,MaxSlippage,0,0,CustomComment,Magic);
               if(TK!=-1) break;
            }
         }
         break;
      case ORDERSELL:
         if(OnlyBuyMode!=true)
         {
            for(i=0;i<NumberOfTry;i++)
            {
               TK=OrderSend(Symbol(),OP_SELL,lcLots,Bid,MaxSlippage,0,0,CustomComment,Magic);
               if(TK!=-1) break;
            }
         }
         break;
      }
   }
   //---------------------------------------------------
   if(UseControlBuy==true)
   {
      if(HideBuyTP_SL==true)
      {
         sVirtualSLPipType(OP_BUY,StopLossPipsBuy,Magic);
         sVirtualTPPipType(OP_BUY,StopLossPipsBuy,Magic);
      }
      else
      {
         sSLEntryFixType(OP_BUY,StopLossPipsBuy,Magic);
         sTPEntryFixType(OP_BUY,StopLossPipsBuy,Magic);
      }
      if(UseBreakEvenBuy==true) sBreakEvenType(OP_BUY,MoveToBreakEveAtPipsBuy,MoveToBreakEvenLockPipsBuy,Magic);
      if(UseTrailingStopBuy==true)
      {
         sTrailingShow(glTrailing);
         sTrailingAllType(OP_BUY,glTrailing,1,0,TrailingStopBuy,TrailingStepBuy,0,TrailingStepBuy,Magic);
      }
   }
   if(UseControlSell==true)
   {
      if(HideSellTP_SL==true)
      {
         sVirtualSLPipType(OP_SELL,StopLossPipsSell,Magic);
         sVirtualTPPipType(OP_SELL,StopLossPipsSell,Magic);
      }
      else
      {
         sSLEntryFixType(OP_SELL,StopLossPipsSell,Magic);
         sTPEntryFixType(OP_SELL,StopLossPipsSell,Magic);
      }
      if(UseBreakEvenSell==true) sBreakEvenType(OP_SELL,MoveToBreakEveAtPipsSell,MoveToBreakEvenLockPipsSell,Magic);
      if(UseTrailingStopSell==true)
      {
         sTrailingShow(glTrailing);
         sTrailingAllType(OP_SELL,glTrailing,1,0,TrailingStopSell,TrailingStepSell,0,TrailingStepSell,Magic);
      }
   }
   
   //-----------------------------------------------------
   return(0);
}
//------------------------------------------------
int sWPRSignal(int inTF,datetime &inTimeSignal,double &inPriceSignal,int inWprLength=14,int inWprSmooth=3,int inWprSmoothMode=MODE_SMA,int inAverage=9,int inAverageMode=MODE_SMA,int inDzLookBackBars=70,double inDzStartBuyProbability1=0.2,double inDzStartSellProbability1=0.2,double inDzStartBuyProbability2=0.6,double inDzStartSellProbability2=0.6,int inShift=1)
{
   int Result;
   double Data1,Data2,Data1Pre,Data2Pre;
   
   Data1=iCustom(NULL,inTF,"Dynamic double zone WPR 2 dll",inWprLength,inWprSmooth,inWprSmoothMode,inAverage,inAverageMode,inDzLookBackBars,inDzStartBuyProbability1,inDzStartSellProbability1,inDzStartBuyProbability2,inDzStartSellProbability2,0,inShift);
   Data2=iCustom(NULL,inTF,"Dynamic double zone WPR 2 dll",inWprLength,inWprSmooth,inWprSmoothMode,inAverage,inAverageMode,inDzLookBackBars,inDzStartBuyProbability1,inDzStartSellProbability1,inDzStartBuyProbability2,inDzStartSellProbability2,6,inShift);
   Data1Pre=iCustom(NULL,inTF,"Dynamic double zone WPR 2 dll",inWprLength,inWprSmooth,inWprSmoothMode,inAverage,inAverageMode,inDzLookBackBars,inDzStartBuyProbability1,inDzStartSellProbability1,inDzStartBuyProbability2,inDzStartSellProbability2,0,inShift+1);
   Data2Pre=iCustom(NULL,inTF,"Dynamic double zone WPR 2 dll",inWprLength,inWprSmooth,inWprSmoothMode,inAverage,inAverageMode,inDzLookBackBars,inDzStartBuyProbability1,inDzStartSellProbability1,inDzStartBuyProbability2,inDzStartSellProbability2,6,inShift+1);
   if((Data1Pre<Data2Pre)&&(Data1>Data2))
   {
      Result=ORDERBUY;
      inTimeSignal=iTime(NULL,inTF,inShift);
      inPriceSignal=iLow(NULL,inTF,inShift);
   }
   if((Data1Pre>Data2Pre)&&(Data1<Data2))
   {
      Result=ORDERSELL;
      inTimeSignal=iTime(NULL,inTF,inShift);
      inPriceSignal=iHigh(NULL,inTF,inShift);
   }
   
   sTextShow("Signal: "+Result,10,20);
   sCommentName("WPR: "+Result,inPriceSignal,inTimeSignal);
   return(Result);
}

//----------------------------------------------------------
bool sCloseTrendChange(int inTrend,int inMagic=0,string inComment="",string inSymbol="")
{
   bool Result;
   int i;
   bool FL1;
   
   for(i=0;i<OrdersTotal();i++)
   {
      dummyResult = OrderSelect(i,SELECT_BY_POS);
      if(((OrderSymbol()==inSymbol)||(inSymbol==""))&&((OrderMagicNumber()==inMagic)||(inMagic==0))&&((OrderComment()==inComment)||(inComment==""))&&((OrderType()==OP_SELL)||(OrderType()==OP_BUY)))
      {
         FL1=false;
         if((OrderType()==OP_BUY)&&(inTrend==ORDERSELL)) FL1=true;
         if((OrderType()==OP_SELL)&&(inTrend==ORDERBUY)) FL1=true;
         if(FL1==true) sOrderClose(OrderTicket());
      }
   }
   return(Result);
}
//------------------------------------------------------------
string glError[8]=  {
                     "",
                     "Parameters Error MM",
                     "Error Parametros ExitSettingsActiveOrder",
                     "Parameters Error ContinuousMode",
                     "Parameter Errors ControlBuy",
                     "Parameter Error ControlSell",
                     "Breakeven And TrailingStop Errors",
                     "Error Parametros ExitSettingsActiveOrder"
                     };

void sAlert(bool &inData[])
{
   int i;
   for(i=0;i<=ArraySize(inData);i++)
   {
      if(inData[i]==true)
      {
         if(ShowMessages==true) sTextShow(glError[i],10,100+i*20);
         if(ShowAlerts==true) Alert(glError[i]);
         inData[i]=false;
      }
      
   }
}//-----------------------------------------------------------------------------------------------
int GrupoRenko(string inName=AUTHOR)
{
   int total=ObjectsTotal();
   string object_name[];
   ArrayResize(object_name,total);
   for(int j=0;j<total;j++)
   {
      object_name[j]=ObjectName(j);
   }
   for(j=0;j<total;j++)
   {
      if(StringSubstr(object_name[j],0,StringLen(inName))==inName)
      {
      ObjectDelete(object_name[j]);   
      }
   }
   if(sError_Show("XOA DOI TUONG")>0) return(1); else return(-1);
}
//----------------------------------
double sMoneyManager(double &inLots,double inRiskPercent=10,double inLotsMax=0,double inLotsMin=0)
{

   inLots=(inRiskPercent/100.0)*AccountFreeMargin()/(100000.0/AccountLeverage());///100000.0;
   if((inLotsMax!=0)&&(inLotsMin!=0)) inLots=MathMin(inLotsMax,MathMax(inLotsMin,inLots));
   inLots=NormalizeDouble(inLots,2);
   sTextShow("Free Margin: "+DoubleToStr(AccountFreeMargin(),2),10,200);
   sTextShow("Margin: "+DoubleToStr(AccountMargin(),2),10,220);
   sTextShow("Leverage: "+AccountLeverage(),10,240);
   
   if(GetLastError()==0) return(1); else return(-1);
}
//-----------------------------------------
int sOrderLast(int inMagic=0,string inComment="",string inSymbol="")
{
   int TK=OrderTicket();
   int i;
   datetime lcTime;
   int Result=0;
   
   for(i=0;i<OrdersTotal();i++)
   {
      dummyResult = OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(((OrderSymbol()==inSymbol)||(inSymbol==""))&&((OrderMagicNumber()==inMagic)||(inMagic==0))&&((OrderComment()==inComment)||(inComment==""))&&((OrderType()==OP_SELL)||(OrderType()==OP_BUY)))
      {
         if(OrderOpenTime()>lcTime)
         {
            Result=OrderTicket();
            lcTime=OrderOpenTime();
         }
      }
   }
   for(i=0;i<OrdersHistoryTotal();i++)
   {
      dummyResult = OrderSelect(i,SELECT_BY_POS,MODE_HISTORY);
      if(((OrderSymbol()==inSymbol)||(inSymbol==""))&&((OrderMagicNumber()==inMagic)||(inMagic==0))&&((OrderComment()==inComment)||(inComment==""))&&((OrderType()==OP_SELL)||(OrderType()==OP_BUY)))
      {
         if(OrderOpenTime()>lcTime)
         {
            Result=OrderTicket();
            lcTime=OrderOpenTime();
         }
      }
   }
   
   if(TK!=-1) dummyResult = OrderSelect(TK,SELECT_BY_TICKET);
   return(Result);
}
//------------------------------------------------------
bool sLimitOrder(bool &inTradeAllow,int inTF,datetime inTimeSignal,int inOrderMax=0,int inMagic=0,string inComment="",string inSymbol="")
{
   bool R1,R2,R3;
   
   inTradeAllow=true;
   R1=(sOrderSum(inMagic,inComment,inSymbol) >= inOrderMax)&&(inOrderMax!=0);
   R2=(sTimePastTicket(sOrderLast(inMagic,inComment,inSymbol)) <= inTF)&&(sTimePastTicket(sOrderLast(inMagic,inComment,inSymbol))>=0);
   R3=sOrderLastTime(inMagic,inComment,inSymbol) > inTimeSignal;
   if((R1==true)||(R2==true)||(R3==true)) inTradeAllow=false;

   return(inTradeAllow);
}
//-----------------------------------
double sPoint(string inSymbol="")
{
   double Result;
   int lcDigit;
   double lcPoint;
   if(inSymbol!="")
   {
   lcDigit=MarketInfo(inSymbol,MODE_DIGITS);
   lcPoint=MarketInfo(inSymbol,MODE_POINT);
   }
   if(inSymbol=="")
   {
   lcDigit=Digits;
   lcPoint=Point;
   }
   switch(lcDigit)
   {
   case 3:
   case 5:
      Result=lcPoint*10;
      break;
   case 2:
   case 4:
      Result=1.0*lcPoint;
      break;
   }
   
   return(Result);
}
//--------------------------------------
int sOrderSum(int inMagic=0,string inComment="",string inSymbol="")
{
   int TK=OrderTicket();
   int i;
   int Result;
   
   for(i=0;i<OrdersTotal();i++)
   {
      dummyResult = OrderSelect(i,SELECT_BY_POS);
      
      if(((OrderSymbol()==inSymbol)||(inSymbol==""))&&((OrderMagicNumber()==inMagic)||(inMagic==0))&&((OrderComment()==inComment)||(inComment==""))&&((OrderType()==OP_SELL)||(OrderType()==OP_BUY)))
      {
         Result++;
      }      
   }
   
   sError_Show("ORDER SUM");
   if(TK!=-1) dummyResult = OrderSelect(TK,SELECT_BY_TICKET);
   return(Result);
}
//------------------------------------------------
int sVirtualSLPipType(int inType,double inSL,int inMagic=0,string inComment="",string inSymbol="")
{
   int TK=OrderTicket();
   int i;
   double SL;
   for(i=0;i<OrdersTotal();i++)
   {
      dummyResult = OrderSelect(i,SELECT_BY_POS);
      if((inSL!=0)&&((OrderSymbol()==inSymbol)||(inSymbol==""))&&((OrderMagicNumber()==inMagic)||(inMagic==0))&&((OrderComment()==inComment)||(inComment==""))&&(OrderType()==inType))
      {
         switch(OrderType())
         {
         case OP_BUY:
            SL=OrderOpenPrice() - inSL*sPoint();
            if(MarketInfo(OrderSymbol(),MODE_BID)<=SL) sOrderClose(OrderTicket());
            break;
         case OP_SELL:
            SL=OrderOpenPrice() + inSL*sPoint();
            if(MarketInfo(OrderSymbol(),MODE_ASK)>=SL) sOrderClose(OrderTicket());
            break;
         }
      }
      
   }
   if(TK!=0) dummyResult = OrderSelect(TK,SELECT_BY_TICKET);
   if(sError_Show("VIRTUAL SL")>0) return (1); else return(-1);
}
//---------------------------------------
int sVirtualTPPipType(int inType,double inTP,int inMagic=0,string inComment="",string inSymbol="")
{
   int TK=OrderTicket();
   int i;
   double TP;
   for(i=0;i<OrdersTotal();i++)
   {
      dummyResult = OrderSelect(i,SELECT_BY_POS);
      if((inTP!=0)&&((OrderSymbol()==inSymbol)||(inSymbol==""))&&((OrderMagicNumber()==inMagic)||(inMagic==0))&&((OrderComment()==inComment)||(inComment==""))&&(OrderType()==inType))
      {
         switch(OrderType())
         {
         case OP_BUY:
            TP=OrderOpenPrice() + inTP*sPoint();
            if(MarketInfo(OrderSymbol(),MODE_BID)>=TP) sOrderClose(OrderTicket());
            break;
         case OP_SELL:
            TP=OrderOpenPrice() - inTP*sPoint();
            if(MarketInfo(OrderSymbol(),MODE_ASK)<=TP) sOrderClose(OrderTicket());
            break;
         }
      }
      
   }
   if(TK!=0) dummyResult = OrderSelect(TK,SELECT_BY_TICKET);
   if(sError_Show("VIRTUAL TP")>0) return (1); else return(-1);
}
//----------------------------------------------
int sSLEntryFixType(int inType,double inFixSL=100,int inMagic=0,string inComment="",string inSymbol="",double inSlipage=0,double inStep=1)
{
   int TK=OrderTicket();
   int i;
   bool RS;
   double SL;
   
   for(i=0;i<OrdersTotal();i++)
   {
      dummyResult = OrderSelect(i,SELECT_BY_POS);
//      if((inFixSL!=0)&&(OrderStopLoss()==0)&&(OrderSymbol()==Symbol()))
      if((inFixSL!=0)&&(OrderStopLoss()==0)&&((OrderSymbol()==inSymbol)||(inSymbol==""))&&((OrderMagicNumber()==inMagic)||(inMagic==0))&&((OrderComment()==inComment)||(inComment==""))&&(OrderType()==inType))
      {
         switch(OrderType())
         {
         case OP_BUYSTOP:
         case OP_BUY:
            SL=OrderOpenPrice() - inFixSL*sPoint(OrderSymbol()) - inSlipage*sPoint(OrderSymbol());
            break;
         case OP_SELLSTOP:
         case OP_SELL:
            SL=OrderOpenPrice() + inFixSL*sPoint(OrderSymbol()) + inSlipage*sPoint(OrderSymbol());
            break;
         }
//         Print("SL ENTRY:",OrderTicket(),"--->"+DoubleToStr(SL,5));
         RS=OrderModify(OrderTicket(),OrderOpenPrice(),SL,OrderTakeProfit(),0);
        
      }
   }
   
   if(TK!=-1) dummyResult = OrderSelect(TK,SELECT_BY_TICKET);   
   if(sError_Show("SL ENTRY FIX")>0) return (1); else return(-1);
}
//---------------------------------------------------
int sTPEntryFixType(int inType,double inFixTP=150,int inMagic=0,string inComment="",string inSymbol="",double inSlipage=0,double inStep=1)
{
   int TK=OrderTicket();
   int i;
   bool RS;
   double TP;
   
   for(i=0;i<OrdersTotal();i++)
   {
      dummyResult = OrderSelect(i,SELECT_BY_POS);
//      if((inFixTP!=0)&&(OrderTakeProfit()==0)&&(OrderSymbol()==Symbol()))
      if((inFixTP!=0)&&(OrderTakeProfit()==0)&&((OrderSymbol()==inSymbol)||(inSymbol==""))&&((OrderMagicNumber()==inMagic)||(inMagic==0))&&((OrderComment()==inComment)||(inComment==""))&&(OrderType()==inType))
      {
         switch(OrderType())
         {
         case OP_BUYSTOP:
         case OP_BUY:
            TP=OrderOpenPrice() + inFixTP*sPoint(OrderSymbol()) - inSlipage*sPoint(OrderSymbol());
            break;
         case OP_SELLSTOP:
         case OP_SELL:
            TP=OrderOpenPrice() - inFixTP*sPoint(OrderSymbol()) + inSlipage*sPoint(OrderSymbol());
            break;
         }
//         Print("TP ENTRY:",OrderTicket(),"--->"+DoubleToStr(TP,5));
         RS=OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),TP,0);
        
      }
   }
   
   if(TK!=-1) dummyResult = OrderSelect(TK,SELECT_BY_TICKET);   
   if(sError_Show("TP ENTRY FIX")>0) return (1); else return(-1);
}
//----------------------------------
int sBreakEvenType(int inType,double inMin=10,double inBETo=0,int inMagic=0,string inComment="",string inSymbol="",int inTry=10)
{
//   int TK=OrderTicket();
   int i,j;
   bool FL;
   double SL;
   double SL1;
   
   for(i=0;i<OrdersTotal();i++)
   {
      dummyResult = OrderSelect(i,SELECT_BY_POS);
      if(((OrderSymbol()==inSymbol)||(inSymbol==""))&&((OrderMagicNumber()==inMagic)||(inMagic==0))&&((OrderComment()==inComment)||(inComment==""))&&(OrderType()==inType))
      {
         if(sOrderProfit(OrderTicket())>inMin)
         {
            SL=NormalizeDouble(OrderStopLoss(),MarketInfo(OrderSymbol(),MODE_DIGITS));
            switch(OrderType())
            {
            case OP_BUY:
                  SL1=OrderOpenPrice() + inBETo*sPoint(OrderSymbol());
                  SL1=NormalizeDouble(SL1,MarketInfo(OrderSymbol(),MODE_DIGITS));
                  if((SL1!=SL)&&((OrderStopLoss()<OrderOpenPrice())||(OrderStopLoss()==0)))
                  {
                     for(j=1;j<inTry;j++)
                     {
                        FL=OrderModify(OrderTicket(),OrderOpenPrice(),SL1,OrderTakeProfit(),0);
                        if(FL!=0) break;
                     }
                  }
               break;
            case OP_SELL:
                  SL1=OrderOpenPrice() - inBETo*sPoint(OrderSymbol());
                  SL1=NormalizeDouble(SL1,MarketInfo(OrderSymbol(),MODE_DIGITS));
                  if((SL1!=SL)&&((OrderStopLoss()>OrderOpenPrice())||(OrderStopLoss()==0)))
                  {
                     for(j=1;j<inTry;j++)
                     {
                        FL=OrderModify(OrderTicket(),OrderOpenPrice(),SL1,OrderTakeProfit(),0);
                        if(FL!=0) break;
                     }
                  }
               break;
            }
         }
      }
   }
   
   if(GetLastError()!=0) glErrorBool[6]=true;
//   if(TK!=-1) OrderSelect(TK,SELECT_BY_TICKET);
   if(sError_Show("BREAK EVEN ENTRY")>0) return (1);
   return(0);
}
//------------------------------------------------
void sTrailingShow(double& inData[][])
{
   int TK=OrderTicket();
   int i;
   int lcTicket;
   
   for(i=0;i<OrdersTotal();i++)
   {
      dummyResult = OrderSelect(i,SELECT_BY_POS);
      for(i=0;i<ArrayRange(inData,0);i++)
      {
         lcTicket=inData[i][0];
         if(OrderTicket()==lcTicket)
         {
            sCommentName("Trailing Stop: " + DoubleToStr(inData[i][0],0) + " - "+DoubleToStr(inData[i][1],1) + " - "+DoubleToStr(inData[i][2],1) + " - "+DoubleToStr(inData[i][3],1)+" SL:"+DoubleToStr(inData[i][4],5) + " - Pip:"+DoubleToStr(inData[i][5],1) ,OrderOpenPrice(),OrderOpenTime());
            sCommentName("Start Trailing Here: "+ OrderTicket() + " - "+ DoubleToStr(inData[i][6],5),inData[i][6],OrderOpenTime());
            sCommentName("SL:"+DoubleToStr(inData[i][4],5),inData[i][4],Time[0]);
            break;
         }
      }
   }
   
   if(TK!=-1) dummyResult = OrderSelect(TK,SELECT_BY_TICKET);
}
//-----------------------------------------
//inType: 0-Real Hard Trailing, 1-Virtual Trailing
//inOption: 0-Private trailing, 1-Basket trailing
void sTrailingAllType(int inOrderType,double &inData[][],int inType=1,int inOption=0,double inPipStart=15,double inStep=1,double inPipLock=0,double inJump=1,int inMagic=0,string inComment="",string inSymbol="")
{
//   int TK=OrderTicket();
   int i,j;
   if(OrdersTotal()>ArrayRange(inData,0)) ArrayResize(inData,OrdersTotal());

   for(i=0;i<OrdersTotal();i++)
   {
      dummyResult = OrderSelect(i,SELECT_BY_POS);
      if(((OrderSymbol()==inSymbol)||(inSymbol==""))&&((OrderMagicNumber()==inMagic)||(inMagic==0))&&((OrderComment()==inComment)||(inComment==""))&&(OrderType()==inOrderType))
      {
         sTrailingClear(inData);

//------------------------------------------------------   
         int PS;
         int lcTicket;
         int lcIndex;
         PS=-1;  
         for(j=0;j<ArrayRange(inData,0);j++)
         {
            lcTicket=inData[j][0];
            if(lcTicket==OrderTicket())
            {
               PS=j;
               break;
            }
         }
         if(PS==-1)
         {
            for(j=0;j<ArrayRange(inData,0);j++)
            {
               if(inData[j][0]==0)
               {
                  inData[j][0]=OrderTicket();
                  PS=j;
                  break;
               }
            }
         }       
         inData[PS][1]=sOrderProfit(OrderTicket(),1,3);
         if(inData[PS][1]>inData[PS][2]) inData[PS][2]=inData[PS][1];
         if(inData[PS][1]<inData[PS][3]) inData[PS][3]=inData[PS][1];
         switch(OrderType())
         {
         case OP_BUY:
            inData[PS][6]=OrderOpenPrice() + inPipStart*sPoint();
            lcIndex=(inData[PS][2] - inPipStart)/inStep;
            inData[PS][4]=OrderOpenPrice() + inPipLock*sPoint() + lcIndex*inJump*sPoint();
            inData[PS][5]=inPipLock + lcIndex*inJump;
            break;
         case OP_SELL:
            inData[PS][6]=OrderOpenPrice() - inPipStart*sPoint();
            lcIndex=(inData[PS][2] - inPipStart)/inStep;
            inData[PS][4]=OrderOpenPrice() - inPipLock*sPoint() - lcIndex*inJump*sPoint();
            inData[PS][5]=inPipLock + lcIndex*inJump;
            break;
         }
//---------------------------------------------------------------------------------------------------------
         int PSBasket;
         if(inData[PS][2]>=inPipStart)
         {
            switch(inOption)
            {
            case 0:
               switch(inType)
               {
               case 0:
                  sRealSLTicket(OrderTicket(),inData[PS][4]);
                  break;
               case 1:
                  sVirtualSLTicket(OrderTicket(),inData[PS][4]);
                  break;
               }
               break;
            case 1:
               PSBasket=sTrailingBasket(inData);
               switch(inType)
               {
               case 0:
                  sRealSLTicket(OrderTicket(),inData[PSBasket][4]);
                  break;
               case 1:
                  sVirtualSLTicket(OrderTicket(),inData[PSBasket][4]);
                  break;
               }
               break;
            }
         }
      }
   }
   
   if(GetLastError()!=0) glError[6]=true;
   
//   if(TK!=-1) OrderSelect(TK,SELECT_BY_TICKET);
}
//-------------------------------------------------
void sTextShow(string inText,int inX=10,int inY=10,color inColor=White,string inName=AUTHOR,bool inShow=true)
{
   if(inShow==true)
   {
      string Name;
      Name=inName + " " + MathRand()+MathRand();
      ObjectCreate(Name,OBJ_LABEL,0,0,0);
      ObjectSet(Name,OBJPROP_XDISTANCE,inX);
      ObjectSet(Name,OBJPROP_YDISTANCE,inY);
      ObjectSetText(Name,inText,10,"Tahoma",inColor);
   }
}
//------------------------------------------------
void sCommentName(string inMsg,double inPrice,datetime inTime,string inName=AUTHOR,bool inShow=true)
{
   if(inShow==true)
   {
      string Name;
      Name=inName+" "+MathRand()+MathRand();
      ObjectCreate(Name,OBJ_TEXT,0,inTime,inPrice);
      ObjectSetText(Name,inMsg,8,"Tahoma",White);
   }
}
//----------------------------------
int sOrderClose(int inTicket,int inTry=100)
{
   int TK=OrderTicket();
   bool FL,FL1;
   int i;
   
   FL1=OrderSelect(inTicket,SELECT_BY_TICKET);
   if(FL1==true)
   {
      switch(OrderType())
      {
      case OP_BUY:
         for(i=0;i<inTry;i++)
         {
            FL=OrderClose(inTicket,OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),0);
            if(FL==true) break;
         }
         break;
      case OP_SELL:
         for(i=0;i<inTry;i++)
         {
            FL=OrderClose(inTicket,OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),0);
            if(FL==true) break;
         }
         break;
      case OP_BUYSTOP:
      case OP_SELLSTOP:
      case OP_BUYLIMIT:
      case OP_SELLLIMIT:
         for(i=0;i<inTry;i++)
         {
            FL=OrderDelete(inTicket);
            if(FL==true) break;
         }
         break;
      }
   }
   
   if(TK!=0) dummyResult = OrderSelect(TK,SELECT_BY_TICKET);
   if(sError_Show("ORDER CLOSE")>0) return (1); else return(-1);
}
//-----------------------------------------
int sError_Show(string inComment="RETURN ERROR:",bool inShow=false)
{
   inComment=inComment+" ERROR:";
   
   int ERROR=GetLastError();
   switch(ERROR)
   {
   case 0: return(1);
   default: 
      if(inShow==true) Print(inComment,ERROR);
      return(-1);
   }
}
//----------------------------
int sTimePastTicket(int inTicket,int inType=1)
{
   int TK=OrderTicket();
   int i;
   int Result[10];
   
   Result[0]=-1;
   for(i=0;i<OrdersTotal();i++)
   {
      dummyResult = OrderSelect(i,SELECT_BY_POS);
      if(OrderTicket()==inTicket)
      {
         Result[1]=sTimeConvert(TimeCurrent(),inType);
         Result[2]=sTimeConvert(OrderOpenTime(),inType);
         Result[0]=Result[1]-Result[2];
      }
   }
   
   if(TK!=-1) dummyResult = OrderSelect(TK,SELECT_BY_TICKET);
   return (Result[0]);
}
//-----------------------------------------
int sOrderLastTime(int inMagic=0,string inComment="",string inSymbol="")
{
   int TK=OrderTicket();
   int i;
   datetime lcTime;
   
   for(i=0;i<OrdersTotal();i++)
   {
      dummyResult = OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(((OrderSymbol()==inSymbol)||(inSymbol==""))&&((OrderMagicNumber()==inMagic)||(inMagic==0))&&((OrderComment()==inComment)||(inComment==""))&&((OrderType()==OP_SELL)||(OrderType()==OP_BUY)))
      {
         if(OrderOpenTime()>lcTime) lcTime=OrderOpenTime();
      }
   }
   for(i=0;i<OrdersHistoryTotal();i++)
   {
      dummyResult = OrderSelect(i,SELECT_BY_POS,MODE_HISTORY);
      if(((OrderSymbol()==inSymbol)||(inSymbol==""))&&((OrderMagicNumber()==inMagic)||(inMagic==0))&&((OrderComment()==inComment)||(inComment==""))&&((OrderType()==OP_SELL)||(OrderType()==OP_BUY)))
      {
         if(OrderOpenTime()>lcTime) lcTime=OrderOpenTime();
      }
   }
   
   if(TK!=-1) dummyResult = OrderSelect(TK,SELECT_BY_TICKET);
   return(lcTime);
}
//------------------------------

#define PROFIT_PIPS     1
#define PROFIT_PIPS_SL  2
double sOrderProfit(int inTicket,int inType=1,int inMode=1)
{
   int TK=OrderTicket();
   
   bool DB;
   double Result[10];
   DB=OrderSelect(inTicket,SELECT_BY_TICKET);
   switch(inMode)
   {
   case 0:
      switch(OrderType())
      {
      case OP_BUY:   inMode=MODE_ASK;break;
      case OP_SELL:  inMode=MODE_BID;break;
      }
      break;
   case 1: inMode=MODE_BID;break;
   case 2: inMode=MODE_ASK;break;
   default:
      switch(OrderType())
      {
      case OP_BUY:   inMode=MODE_BID;break;
      case OP_SELL:  inMode=MODE_ASK;break;
      }
      break;
   }
   if(DB==true)
   {
      Result[0]=OrderProfit()+OrderCommission()+OrderSwap();
      switch(OrderType())
      {
      case OP_BUY:
         Result[1]=1.0*(MarketInfo(OrderSymbol(),inMode)-OrderOpenPrice())/sPoint(OrderSymbol());
         Result[2]=1.0*(OrderStopLoss()-OrderOpenPrice())/sPoint(OrderSymbol());
         Result[3]=(OrderStopLoss()-OrderOpenPrice())*OrderLots()*100000*(0.00001/sPoint(OrderSymbol()));
         Result[4]=1.0*Result[3]/AccountBalance()*100;
         Result[5]=1.0*Result[1]*sPoint(OrderSymbol())*OrderLots()*100000*(0.00001/sPoint(OrderSymbol()))/AccountBalance()*100;
         break;
      case OP_SELL:
         Result[1]=1.0*(OrderOpenPrice()-MarketInfo(OrderSymbol(),inMode))/sPoint(OrderSymbol());
         Result[2]=1.0*(OrderOpenPrice()-OrderStopLoss())/sPoint(OrderSymbol());
         Result[3]=(OrderOpenPrice()-OrderStopLoss())*OrderLots()*100000*(0.00001/sPoint(OrderSymbol()));
         Result[4]=1.0*Result[3]/AccountBalance()*100;
         Result[5]=1.0*Result[1]*sPoint(OrderSymbol())*OrderLots()*100000*(0.00001/sPoint(OrderSymbol()))/AccountBalance()*100;
         break;
      }
      
      
   }
   
   if(TK!=-1) dummyResult = OrderSelect(TK,SELECT_BY_TICKET);
   return (Result[inType]);
}
//---------------------------------------
void sTrailingClear(double &inData[][])
{
   int TK=OrderTicket();
   int i,j;
   int lcTicket;
   bool Result;
   
   for(i=0;i<ArrayRange(inData,0);i++)
   {
      Result=true;
      for(j=0;j<OrdersTotal();j++)
      {
         dummyResult = OrderSelect(j,SELECT_BY_POS);
         lcTicket=inData[i][0];
         if(OrderTicket()==lcTicket)
         {
         Result=false;
         break;
         }
      }
      if(Result==true)
      {
         for(j=0;j<10;j++) inData[i][j]=0;
      }
   }
   if(TK!=-1) dummyResult = OrderSelect(TK,SELECT_BY_TICKET);
}
//------------------------------------------------
int sRealSLTicket(int inTicket,double inPrice)
{
   int TK=OrderTicket();
   bool FL;
   double SL;
   double SL1;
   
   
   FL=OrderSelect(inTicket,SELECT_BY_TICKET);
   if(FL==true)
   {
      SL1=NormalizeDouble(inPrice,MarketInfo(OrderSymbol(),MODE_DIGITS));
      SL=NormalizeDouble(OrderStopLoss(),MarketInfo(OrderSymbol(),MODE_DIGITS));
      switch(OrderType())
      {
      case OP_BUY:
         if((MarketInfo(OrderSymbol(),MODE_BID)>inPrice)&&(SL1!=SL)) dummyResult = OrderModify(OrderTicket(),OrderOpenPrice(),SL1,OrderTakeProfit(),0);
         break;
      case OP_SELL:
         if((MarketInfo(OrderSymbol(),MODE_ASK)<inPrice)&&(SL1!=SL)) dummyResult = OrderModify(OrderTicket(),OrderOpenPrice(),SL1,OrderTakeProfit(),0);
         break;
      }
   }
   
   if(TK!=-1) dummyResult = OrderSelect(TK,SELECT_BY_TICKET);
   if(sError_Show("REAL SL TICKET")>0) return (1); else return(-1);
}
//------------------------------------------------
int sVirtualSLTicket(int inTicket,double inPrice)
{
   int TK=OrderTicket();
   bool FL;
   
   FL=OrderSelect(inTicket,SELECT_BY_TICKET);
   if(FL==true)
   {
      switch(OrderType())
      {
      case OP_BUY:
         if((MarketInfo(OrderSymbol(),MODE_BID)<=inPrice)&&(inPrice!=0)) sOrderClose(OrderTicket());
         break;
      case OP_SELL:
         if((MarketInfo(OrderSymbol(),MODE_ASK)>=inPrice)&&(inPrice!=0)) sOrderClose(OrderTicket());
         break;
      }
   }
   
   if(TK!=0) dummyResult = OrderSelect(TK,SELECT_BY_TICKET);
   if(sError_Show("VIRTUAL SL TICKET")>0) return (1); else return(-1);
}
//-----------------------
int sTrailingBasket(double& inData[][])
{
   int TK=OrderTicket();
   int i,j;
   int PS;
   int lcTicket;
   double lcBasketData;
   int Result;
   
   for(i=0;i<OrdersTotal();i++)
   {
      dummyResult = OrderSelect(i,SELECT_BY_POS);
      PS=-1;
      for(j=0;j<ArrayRange(inData,0);j++)
      {
         lcTicket=inData[j][0];
         if(OrderTicket()==lcTicket)
         {
            PS=j;
            break;
         }
      }
      if(PS==-1)continue;
      if(inData[PS][4]>lcBasketData) Result=PS;
   }
   sTextShow("Basket Order SL: "+DoubleToStr(inData[Result][4],5),10,140);
   if(TK!=-1) dummyResult = OrderSelect(TK,SELECT_BY_TICKET);
   return(Result);
}
//-------------------------------------
double sTimeConvert(datetime inTime,int inType=1)
{
   int Data[10];
   double Result;
   
   Data[1]=TimeSeconds(inTime);
   Data[2]=TimeMinute(inTime);
   Data[3]=TimeHour(inTime);
   Data[4]=TimeDayOfYear(inTime);
   Data[5]=TimeMonth(inTime);
   Data[6]=TimeYear(inTime);
   
   switch(inType)
   {
   case 0:
      Result=Data[1] + Data[2]*60 + Data[3]*60*60 + Data[4]*60*60*24;
      break;
   case 1:
      Result=1.0*(Data[1] + Data[2]*60 + Data[3]*60*60 + Data[4]*60*60*24)/60;
      break;
   case 2:
      Result=1.0*(Data[1] + Data[2]*60 + Data[3]*60*60 + Data[4]*60*60*24)/60/60;
      break;
   case 3:
      Result=1.0*(Data[1] + Data[2]*60 + Data[3]*60*60 + Data[4]*60*60*24)/60/60/24;
      break;
   }
   
   sError_Show("TIME CONVERT");
   return (Result);
}

